package com.ruoyi.mybasic.service.Impl;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.mybasic.common.domain.request.*;
import com.ruoyi.mybasic.common.domain.response.*;
import com.ruoyi.mybasic.common.domain.emal.IncomeAmount;
import com.ruoyi.mybasic.mapper.PurseMapper;
import com.ruoyi.mybasic.service.PurseService;
import com.ruoyi.system.api.RemoteFileService;
import com.ruoyi.system.api.domain.SysFile;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * @ClassName PurseServiceImpl
 * @Description 描述
 * @Author WenHao.Sao
 */
@Service
public class PurseServiceImpl implements PurseService {

    /** @noinspection SpringJavaInjectionPointsAutowiringInspection*/
    //用于调用文件上传
    @Autowired
    private RemoteFileService remoteFileService;

    /** @noinspection SpringJavaInjectionPointsAutowiringInspection*/
    @Autowired
    private PurseMapper purseMapper;



    /***
     * 用于钱包展示列表
     * 根据登录人 请求对象
     * @return
     */
    @Override
    public R<PurseResponse> show(String userId) {
        PurseResponse purse = purseMapper.show(userId);
        System.out.println(purse);
        if (purse == null){
            return R.fail("没有");
        }else{
            return R.ok(purse,"成功");
        }
    }


    /**
     * 下拉框查询银行卡
     * 银行卡通过id查询
     * @param
     * @return
     */
    //返回一个列表 需修改
    @Override
    public R<List<BankResponse>> bankId(String userId) {
        List<BankResponse> bank = purseMapper.bankId(userId);
        R<List<BankResponse>> ok = R.ok(bank);
        return ok;
    }


    /**
     * 根据用户的userId获取到银行卡里面的余额
     * @param userId
     * @return
     */
    @Override
    public R<BankResponse> bankIdUserId(String userId) {
        BankResponse b = purseMapper.bankIdUserId(userId);
        return R.ok(b);
    }


    /***
     * 进行上传图片 上传银行卡 身份证
     * @param file
     * @return
     */
    @Override
    public R upload(MultipartFile file) {
        R<SysFile> upload1 = remoteFileService.upload(file);
        return R.ok(upload1);
    }
//        if (null == file){
//            return R.fail("图片为空");
//        }
//        String upload = "";
//        try {
//            upload = fastUtil.upload(file);
//            if (null == upload){
//                return R.fail("为空");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
    /**
     * 收入 支出 记录表
     * @return
     */
    @Override
    public R<List<MoneyLogsResponse>> moneyList(String userId) {
        List<MoneyLogsResponse> moneyList = purseMapper.moneyList(userId);
        return R.ok(moneyList);
    }

    /***
     * 支付 支出详情表
     * @return
     */
    @Override
    public R<List<MoneyTypeRequest>> moneyTypeList(String UserId) {
        List<MoneyTypeRequest> moneyTypeList = purseMapper.moneyTypeList(UserId);
        return R.ok(moneyTypeList);

    }


    /***
     * 提现记录表
     * 根据前台传来的userId判断本人用户的提现记录
     * @return
     */
    @Override
    public R<List<MoneyWithdrawResponse>> moneyWithdrawLog(String userId) {
        List<MoneyWithdrawResponse> moneyWithdrawLog = purseMapper.moneyWithdrawLog(userId);
        return R.ok(moneyWithdrawLog);
    }

    /**
     * 提现H币  把余额里面的金额提现成现金到银行卡里面
     * H币以除以十的情况提现到银行卡
     * 判断H币为100才能进行转换
     * H币提现提现功能 判断 提现不能高于 余额数
     * 添加到提现记录里面
     */

    @Override
    public R purseWithdraw(BankId bankId) {
//        调用后台查询我的钱包获取H币数量
        PurseResponse show = purseMapper.show(bankId.getUserId());
        //获取前台输入的值
        int amount1 = bankId.getAmount();
        //校验 如果前台输入的金额跟拥有的金额不匹配者提示重新输入
        if (amount1 * 100 > show.getBalanceFee()){
            return R.fail("余额不够,重新输入");
        }else{
            //根据前台传来的银行卡id 获取到对象
            BankId bank = purseMapper.selectBank(bankId.getId());
            //赋值银行卡余额 原有的加上提现的
            bank.setBankNumber(bank.getBankNumber() + amount1);
            //修改银行卡的余额
            Integer i = purseMapper.updBank(bankId);
            if (i>0){
                //前台的余额进行 减
                show.setBalanceFee(show.getBalanceFee()-(amount1*100));
                //前台的H币进行修改
                Integer i1 = purseMapper.updPurseAmount(bankId);
                if (i1>0){
                    //添加修改过后记录
                    //添加记录表中 添加用户提现user_id 添加提现金额amount 以及当前时间 以及提现状态
                    MoneyWithdrawRequest moneyWithdrawRequest = new MoneyWithdrawRequest();
                    moneyWithdrawRequest.setUserId(bankId.getUserId());
                    moneyWithdrawRequest.setAmount(bankId.getAmount() + "");
                    //添加记录表
                    purseMapper.addMoneyWithdraw(moneyWithdrawRequest);

                }else{
                    return R.fail("H币扣除失败");
                }

                return R.ok("银行卡余额修改成功");
            }else{
                return R.fail("银行卡余额未到账");
            }
        }
    }

//    @Override
//    public R purseWithdraw(PurseRequest purse) {
//
////        调用后台查询我的钱包获取H币数量
//        PurseResponse show = purseMapper.show(purse.getUserId());
//        //获取前台输入的值
//        int amount1 = purse.getAmount();
//        //校验 如果前台输入的金额跟拥有的金额不匹配者提示重新输入
//        if (amount1 * 100 > show.getBalanceFee()){
//            return R.fail("余额不够,重新输入");
//        }else{
//            //根据前台传来的银行卡id 获取到对象
//            BankId bank = purseMapper.selectBank(purse.getId());
//            //赋值银行卡余额 原有的加上提现的
//            bank.setBankNumber(bank.getBankNumber() + amount1);
//
//
//            //前台的余额进行 减
//            show.setBalanceFee(show.getBalanceFee()-(amount1*100));
//
////            Integer i = purseMapper.updPurse(purse);
//            //添加记录表中 添加用户提现user_id 添加提现金额amount 以及当前时间 以及提现状态
//            MoneyWithdrawRequest moneyWithdraw = new MoneyWithdrawRequest();
//            moneyWithdraw.setUserId(purse.getUserId());
//            //更改银行卡里面的余额 应该在加一个修改当前用户的银行卡里面的金额
//            BankResponse bankResponse = new BankResponse();
//            //查询银行卡的余额
//            BankResponse b = purseMapper.selBankNumBank(purse.getId());
//            bankResponse.setNumBank(b.getNumBank() + amount1);
//            System.out.println(bankResponse);
//            //修改银行卡余额
//            Integer b1 = purseMapper.updBankNumBank(purse);
//            if (b1 != null){
//                //添加记录表
//                purseMapper.addMoneyWithdraw(moneyWithdraw);
//                //修改余额
//                PurseResponse i = purseMapper.updPurseBalanceFee(purse);
//                return R.ok(i,"提现成功");
//            }else{
//                return R.fail("提现失败");
//            }
//        }
//    }

    /***
     * 根据钱包的id 返回修改的参数
     * @param purseRequest
     * @return
     */

    @Override
    public R updPurse(PurseRequest purseRequest) {
        Integer i = purseMapper.updPurse(purseRequest);
        if (i>0){
            return R.ok("修改成功");
        }else{
            return R.fail("失败");
        }

    }

    /***
     * 充值模块
     * @param bankId
     * @return
     */
    @Override
    public R<Integer> topUp(BankId bankId) {
        //获取到选择的银行卡 通过前台传来选择银行卡的id 进行查询对象
        BankId bank = purseMapper.bankNumBank(bankId.getId());
        //查询银行卡里面的金额 跟前台输入的金额做对比
        if (bank.getNumBank() < bankId.getAmount()){
            return R.fail("银行卡余额不足");
        }else{
            //获取到前台传来的金额
            int amount = bankId.getAmount();
            //调用当前用户的userId 查询到金额
            PurseResponse show = purseMapper.show(bankId.getUserId());
            //银行卡里面的金额(前台 输入的数据) * 100 加上原有的 钱包金额  进行给钱包金额赋值
            PurseRequest purseRequest = new PurseRequest();
            purseRequest.setBalanceFee((amount * 100) + show.getBalanceFee());

            //修改H币 方法
            Integer i = purseMapper.topUp(bankId);

//            //更改银行卡里面的余额
//            BankId bankId1 = new BankId();
//            //查询银行卡的余额
//            BankResponse b = purseMapper.selBankNumBank(bankId.getId());
//            bankId1.setNumBank(b.getNumBank() - amount);
//            purseMapper.updBankNumBank(bankRequest);
            //添加充值记录表里面
            MoneyWithdrawRequest moneyWithdraw = new MoneyWithdrawRequest();
            //添加用户
            moneyWithdraw.setUserId(bankId.getUserId());
            //添加记录表
            purseMapper.addMoneyWithdraw(moneyWithdraw);

            return R.ok(i>0?200:500,i>0?"充值成功":"充值失败");
        }
    }


    /***
     * 获取到所有记录表
     * 用于修改邀请人和被邀请人增加H币
     * @param invitationRecord
     * @return
     */
    @Override
    public R<List<InvitationRecordRequest>> in(InvitationRecordRequest invitationRecord) {
        //获取所有记录表的数据
        List<InvitationRecordRequest> list = purseMapper.in(invitationRecord);
        //收入  支出记录表
        MoneyLogsRequest moneyLogs = new MoneyLogsRequest();
        //调用枚举
        IncomeAmount tenDollars = IncomeAmount.TEN_DOLLARS;
        int value = tenDollars.getValue();
        //循环这个记录表 拿出 被邀请人的id 和邀请人的id 进行添加300
        for (InvitationRecordRequest record : list) {
            //给邀请人进行添加300
            PurseResponse show = purseMapper.show(invitationRecord.getInviterId() + "");
            show.setBalanceFee(show.getBalanceFee() + value);
            purseMapper.updInviter(record.getInviterId());
            //添加邀请人收入记录表
            moneyLogs.setUserId(invitationRecord.getInviterId());
            moneyLogs.setStatus(2);

            //给被邀请人进行添加300
            PurseResponse show1 = purseMapper.show(invitationRecord.getInviteeId() + "");
            show1.setBalanceFee(show.getBalanceFee() + value);
            purseMapper.updInvitee(record.getInviteeId());
            //添加被邀请人收入记录表
            moneyLogs.setUserId(invitationRecord.getInviteeId());
            moneyLogs.setStatus(2);

            //添加钱包记录表
//            purseMapper.addmonyRecord(invitationRecord.getInviteeId()+"");
//            purseMapper.addmonyRecord(invitationRecord.getInviterId()+"");

            purseMapper.addmonyRecord1(moneyLogs);

        }
        R<List<InvitationRecordRequest>> ok = R.ok(list);
        return ok;
    }


    /***
     * 我的任务
     * 第一个病友圈首发增加10H币
     * 根据当前用户id 获取到病友圈的id
     * 如果病友圈的的发出的时间为当天时间的第一条
     * 那么 那么加10H币
     */


    /**
     * 我的任务
     * 第二个 我的病友圈首发评论 获取到病友圈评论表的id
     * 如果病友圈的评论发出的时间为当天时间的第一条
     * 获取到10 H币
     */


    /**
     * 我的任务 一次性任务
     * 如果这个方法触发一次 则消失不见 或者前台按钮禁用
     * 根据登陆者的id获取到信息 点击完善信息 进行修改
     * 根据当前登录人的用户id获取到这个用户的详情信息 进行修改
     * 如果 第一次修改 则加10H币 如果不是 则不加币
     */


}
